`timescale 1ns / 1ps

module tb_spi_temp;

	// Inputs
	reg clk;
	reg rst;
	wire miso; //Generated by temp sensor simulation

	// Outputs
	wire nCS;
	wire sck;
	wire [12:0] Dout;

	// Instantiate the Unit Under Test (UUT)
	spi uut (
		.clk(clk), 
		.rst(rst), 
		.nCS(nCS), 
		.sck(sck), 
		.miso(miso), 
		.Dout(Dout)
	);

	initial begin
		// Initialize Inputs
		clk = 1;
		rst = 1;
		#102;
		rst = 0;

	end
	
	//Generate clock
	always #10 clk = ~clk;

	//Temp sensor simulation ---------------------------------------------------
	reg [15:0] spi_data = 16'h1234;
	reg [ 3:0] bit_cntr = 15;

	//Bit_cntr: writen in two always blocks - allowed only in simulations
	always @(negedge nCS) bit_cntr <= 15;

	always @(negedge sck) if (~nCS) bit_cntr <= bit_cntr - 1;
	assign miso = spi_data[bit_cntr];
	

endmodule

