module top_level(
    input  clk,
    input  rst,
    
    output cs, //SPI
    output sck,
    input  so,
    
    output [7:0] ld,
    input  [7:0] sw,

    output [3:0] an, //7seg
    output [7:0] seg,
	 
	 output tx_out
);

//----------------------------------------------------------------------------------------
//SPI interface
wire [12:0] temp;
spi spi_temp(
    .clk(clk),
    .rst(rst),
    .miso(so),
    .sck(sck),
    .nCS(cs),
	 .Dout(temp) 	
);

//driving LEDs
assign ld = temp[11:4];


//Data processing
wire [3:0] d0,d1,d2,d3;
dproc dproc (
    .clk(clk), 
    .rst(rst), 
    .temp(temp), 
    .sw(sw),
    .d3(d3), 
    .d2(d2), 
    .d1(d1), 
    .d0(d0)
    );


// 7 segment display
seg7_cntrl seg_7cntrl(
    .clk(clk),
    .rst(rst),
    .din0(d0),
    .din1(d1),
    .din2(d2),
    .din3(d3),
    .an(an),
    .seg(seg)
);


assign tx_out = 1;


endmodule